"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var stream_1 = require("stream");
var DateFakerStream = /** @class */ (function (_super) {
    __extends(DateFakerStream, _super);
    function DateFakerStream(startingDate, endingDate, minInterval, maxInterval) {
        var _this = _super.call(this, { objectMode: true, highWaterMark: 1000 }) || this;
        _this.startingTimestamp = startingDate.getTime();
        _this.endingTimestamp = endingDate.getTime();
        _this.minInterval = Math.ceil(minInterval);
        _this.maxInterval = Math.floor(maxInterval);
        _this.lastGeneratedTimeStamp = _this.startingTimestamp;
        return _this;
    }
    DateFakerStream.prototype._getRndomIncrement = function () {
        return Math.floor(Math.random() * (this.maxInterval - this.minInterval + 1)) + this.minInterval;
    };
    DateFakerStream.prototype._read = function () {
        this.lastGeneratedTimeStamp = this.lastGeneratedTimeStamp + this._getRndomIncrement();
        if (this.lastGeneratedTimeStamp > this.endingTimestamp) {
            this.push(null);
            return;
        }
        this.push(new Date(this.lastGeneratedTimeStamp));
    };
    return DateFakerStream;
}(stream_1.Readable));
exports.default = DateFakerStream;
//# sourceMappingURL=index.js.map